monprojet/monprojet/urls.py
import debug_toolbar
from django.contrib import admin
from django.urls import path, include


urlpatterns = [
    path('', include('polls.urls')),
    path('admin/', admin.site.urls),
    path('__debug__/', include(debug_toolbar.urls)),
]

monprojet/polls/urls.py
from django.urls import path, include
from rest_framework import routers
from . import views

router = routers.DefaultRouter()
router.register(r'polls', views.QuestionViewSet)

urlpatterns = [
    path('', views.IndexView.as_view(), name="home"),
    path('<int:pk>', views.QuestionDetailView.as_view(), name='detail'),
    path('<int:question_id>/results', views.results, name='results'),
    path('<int:question_id>/vote', views.vote, name='vote'),
    path('api/v0/', views.api_root_view, name='api_root'),
    path('api/v0/polls/', views.QuestionAPIListView.as_view(), name='api_polls'),
    path('api/v0/polls/<int:pk>', views.QuestionAPIDetailView.as_view(), name='api_question_detail'),
    path('api/v0/choices/', views.ChoiceAPIListView.as_view(), name='api_choices'),
    path('api/v0/choices/<int:pk>', views.ChoiceAPIDetailView.as_view(), name='api_choices_detail'),
    path('api/v1/', include(router.urls)),
]

monprojet/polls/models.py
from django.db import models


class Category(models.Model):
    name = models.CharField(max_length=200)

    def __str__(self):
        return self.name


class Question(models.Model):
    """Model for Question"""
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published', null=True, blank=True)
    categories = models.ManyToManyField(Category, related_name="questions")

    def __str__(self):
        return self.question_text


class Choice(models.Model):
    """Model for choice"""
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self):
        return self.choice_text

monprojet/polls/views.py
import datetime
import json
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponse, Http404
from django.views.generic import ListView, DetailView
from rest_framework import viewsets
from rest_framework.response import Response
from rest_framework.views import APIView
from rest_framework.generics import GenericAPIView, ListCreateAPIView, RetrieveUpdateDestroyAPIView
from rest_framework import mixins

from .models import Question, Choice
from .serializers import QuestionSerializer, ChoiceSerializer


class IndexView(ListView):
    """Classe vue index basée sur ListView"""
    model = Question
    template_name = 'index.html'
    context_object_name = 'latest_question_list'


class QuestionDetailView(DetailView):
    """Vue question detail"""
    model = Question


def detail(request, question_id):
    question = get_object_or_404(Question, pk=question_id)
    context = {
        'question': question
    }
    return render(
        request,
        'polls/question_detail.html',
        context)

def results(request, question_id):
    response = "Résultats de la question %s."
    return HttpResponse(response % question_id)

def vote(request, question_id):
    return HttpResponse("Vous votez à la question %s." % question_id)

def api_root_view(request):
    return HttpResponse("Bienvenue dans l'API")


class QuestionAPIListView(ListCreateAPIView):
    """API Polls get and post"""

    queryset = Question.objects.all()
    serializer_class = QuestionSerializer


class QuestionAPIDetailView(RetrieveUpdateDestroyAPIView):
    """API Question retrieve, put and delete"""

    queryset = Question.objects.all()
    serializer_class = QuestionSerializer


class QuestionViewSet(viewsets.ModelViewSet):
    queryset = Question.objects.all().order_by("question_text")
    serializer_class = QuestionSerializer


class ChoiceAPIListView(ListCreateAPIView):
    """API Polls get and post"""

    queryset = Choice.objects.all()
    serializer_class = ChoiceSerializer


class ChoiceAPIDetailView(RetrieveUpdateDestroyAPIView):
    """API Polls get and post"""

    queryset = Choice.objects.all()
    serializer_class = ChoiceSerializer

monprojet/polls/templates/base.html
<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <title>Mon application</title>
</head>
<body>

<nav>
    <a href="{% url 'home' %}">Sondages</a>
</nav>

<div class="container">
    {% block content %}
    Insérez votre contenu
    {% endblock %}
</div>
</body>
</html>

monprojet/polls/templates/index.html
{% extends 'base.html' %}

{% block content %}
<h1>Bienvenue sur l'application Sondages !</h1>

{% if latest_question_list %}
<ul>
{% for question in latest_question_list %}
    <li>
        <a href="{% url 'detail' question.id %}">{{ question.question_text }}</a>
    </li>
{% endfor %}
</ul>
{% else %}
<p>No polls are available.</p>
{% endif %}

{% endblock %}

monprojet/polls/templates/polls/question_detail.html
{% extends 'base.html' %}

{% block content %}

<h1>Question {{ question.id }} :<br>
  {{ question.question_text }}</h1>

{% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}

<ul>
{% for choice in question.choice_set.all %}
    <li>{{ choice.choice_text }}</li>
{% endfor %}
</ul>

{% endblock %}